#include "a_Structure.h"
#include "a_List_surplus_moves.h"

//-----------------------------------------------------------------------------------
/*
 *    (Brenkman Andrey)
 *   27.02.2009
*/
//-----------------------------------------------------------------------------------


/*
    70%

     

    .
        -      , 
       .          
  .
   ,  ,       . 
         .      
      .   ,      
     .

 :

          pv_current. 
   ,     public_update_PV_current.  

      pv_best. 
          public_update_PV_best.
        public_update_PV_best_max_depth.

             p_PV_best_point.
            public_update_PV_best_point.

*/

class PV_save
{

//  
//////////////////////////////////////////////////////////////////////////////////////////
private:

	struct PV_line pv_current;//      (    )
	struct PV_line pv_best;//      (  )

	__int32 save_value; //     
	unsigned __int8 save_Depth_Max; //     


//////////////////////////////////////////////////////////////////////////////////////////
public:

	//---------------------------------------------------------------------------
	//   
	struct PV_line * get_pv_best();

	//---------------------------------------------------------------------------
	//   
	struct PV_line * get_pv_current();

	//---------------------------------------------------------------------------
	//      
	void update_PV_best_point
	(
		struct PV_line * const p_PV_best_point//     
	);

	//---------------------------------------------------------------------------
	//    
	void update_PV_best
	(
		const struct PV_line * const p_PV_best_point//     
	);

	//---------------------------------------------------------------------------
	//       
	void update_PV_best_max_depth
	(
		const __int32 & score,//     
		const unsigned __int8 & depth//  
	);

	//---------------------------------------------------------------------------
	//     
	void update_PV_current
	(
		const unsigned __int8 & i,//     
		const unsigned __int8 & depth,//  
		class List_surplus_moves * const p_list_surplus_moves//  
	);

	//---------------------------------------------------------------------------
	//    
	void print_currmove
	(
		class List_surplus_moves * const p_list_surplus_moves,// 
		const unsigned __int8 nodes_0,//     
		const unsigned __int8 i,//    
		const unsigned __int8 Depth_Max//  
	);

	//---------------------------------------------------------------------------
	//     
	void print_pv_line
	(
		const bool colour_move,//   
		const class List_surplus_moves * const p_list_surplus_moves,//  
		const struct PV_line * const p_PV_best_point,//  
		const __int64 print_nodes,//  
		const unsigned __int8 i,//    
		const unsigned __int8 Depth_Max,//  
		const __int32 value,//  
		const bool all_line//   
		//,const double time_nodes//   
	);

};
